#ifdef _MSC_VER
#pragma comment(lib,"ws2_32.lib")
#pragma warning(disable: 4996)  // _CRT_SECURE_NO_WARNINGS, Project properties->Configuration Properties->C/C++->Preprocessor->Preprocessor Definitions
#include <winsock2.h>
#endif

#ifdef __GNUC__
#include <windows.h>
#endif

#include <stdio.h>      // inserire in un browser: http://localhost/index.htm
#include <fcntl.h>      // per gestione file
#include <sys\stat.h>   // per gestione file

#define TCP_PORT   (80)
#define MAXPENDING (100)    /* Numero massimo di connessioni contemporanee */
#define RCVBUFSIZE (4096)   /* Dimensione del buffer di ricezione */

//HTTP response
#define HTTP_RESPONSE_OKIMAGE  "HTTP/1.0 200 OK\r\nContent-Type:image/jpg\r\n\r\n"
#define HTTP_RESPONSE_OKTEXT   "HTTP/1.0 200 OK\r\nContent-Type:text/html\r\n\r\n"
#define HTTP_RESPONSE_NOTFOUND "HTTP/1.0 404 Not Found\r\nContent-Type:text/html\r\n\r\n"
#define HTTP_MESSAGE_NOTFOUND  "<html><body><h1>File non trovato</h1></body></html>"

void *threadHttp(void *in_arg);      /* Thread per ogni client connesso */

void OnError(char *errorMessage)
{
  fprintf(stderr,"%s: %d\n", errorMessage, WSAGetLastError());
  exit(1);
}

int main(void)
{
  WSADATA wsaData;    /* Struttura dati per Winsock */
  int sockServer,sockClient;    /* Socket server e client*/
  struct sockaddr_in addrServer,addrClient;  /* Indirizzi locali server e client*/
  int addrSize;
  DWORD threadID;  /* Thread ID del client */

  WSAStartup(MAKEWORD(2,2), &wsaData); /* inizializzazione libreria Winsock */

  /* Creazione socket server */
  sockServer = socket(AF_INET, SOCK_STREAM, 0);
  memset(&addrServer, 0, sizeof(addrServer));
  addrServer.sin_family = AF_INET;
  addrServer.sin_addr.s_addr = htonl(INADDR_ANY); /* IP locale */
  addrServer.sin_port = htons(TCP_PORT);          /* Porta locale */
  /* Impostazione socket server */
  if (bind(sockServer, (struct sockaddr *)&addrServer, sizeof(addrServer)) <0) OnError("bind() fallita");
  /* Connessione passiva del server */
  if (listen(sockServer, MAXPENDING) < 0) OnError("listen() fallita");

  printf("\t------Web Server------\n\tin listen su porta locale %d...\n\n",TCP_PORT);

  while(1) /* Servizio infinito */
  {
    addrSize = sizeof(addrClient);
    if ((sockClient = accept(sockServer, (struct sockaddr *)&addrClient, &addrSize))<0) OnError("accept() fallita");
    if (CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE) threadHttp, (void *)sockClient, 0, (LPDWORD) &threadID) == NULL) OnError("CreateThread() fallita");
  }
}

void *threadHttp(void *threadArgs)
{
  int sockC,fh;  /* Socket client e file handle*/
  char recvBuff[RCVBUFSIZE],sendBuff[RCVBUFSIZE];  /* buffer di ricezione (per request) e di spedizione (per response) */
  char szHttpString[RCVBUFSIZE], szFileName[MAX_PATH];

  sockC = (int) threadArgs;  /* il socket del client */

  /* ricezione request del browser*/
  if (recv(sockC, recvBuff, RCVBUFSIZE, 0) <=0)
  {
    closesocket(sockC);
    fprintf(stderr,"ERRORE: Ricezione fallita.\n");
    ExitThread(1);
  }
  printf("<<<<<<<Ricevuta Request(%d) '%s' \n<<<<<<<\n", sockC, recvBuff);

  /* Dovrebbe essere una GET. Estrazone del nome del file richiesto */
  sscanf(recvBuff, "%s %s \n", szHttpString, szFileName);
  if (strcmp(szHttpString, "GET") != 0)  // Vediamo se  una GET
  {
    printf("ERRORE: La request non  una GET [szHttpString = '%s']\n", szHttpString);
    closesocket(sockC);
    ExitThread(2);
  }

  // La request era una GET. Apro il file...
  fh = open(&szFileName[1], O_RDONLY | O_BINARY, S_IREAD | S_IWRITE);  // dal secondo carattere per saltare '\'
  if (fh == -1)  // il file non esiste
  {
    printf("ERRORE: Il file '%s' non esiste. Response: HTTP 404 \n", &szFileName[1]);
    strcpy(sendBuff, HTTP_RESPONSE_NOTFOUND);
    printf(">>>>>>> Response: '%s' \n", sendBuff);
    send(sockC, sendBuff, strlen(sendBuff), 0);
    strcpy(sendBuff, HTTP_MESSAGE_NOTFOUND);
    printf(">>>>>>> Message Error '%s' \n", sendBuff);
    send(sockC, sendBuff, strlen(sendBuff), 0);
    closesocket(sockC);
    ExitThread(3);
  }

  // Si verifica che il file richiesto non sia in giro per l'hard disk...
  if ((szFileName[1] == '.') || (szFileName[1] == '/') || (szFileName[1] == '\\') || (szFileName[2] == ':'))
  {
    printf("ERRORE: Il file richiesto non  disponibile ['%s'] \n", &szFileName[1]);
    close(fh);
    closesocket(sockC);
    ExitThread(4);
  }

  /* Che Response inviare?*/
  if (strstr(szFileName, ".jpg") != NULL) strcpy(sendBuff, HTTP_RESPONSE_OKIMAGE); else strcpy(sendBuff, HTTP_RESPONSE_OKTEXT);
  printf(">>>>>>> Response(%d): '%s' \n",sockC, sendBuff);
  send(sockC, sendBuff, strlen(sendBuff), 0);

  printf(">>>>>>> file richiesto(%d): '%s' \n\n",sockC, &szFileName[1]);
  while(1)
  {
    int buf_len;

    buf_len = read(fh, sendBuff, RCVBUFSIZE);
    if (buf_len == 0) break;
    send(sockC, sendBuff, buf_len, 0);
  }

  /* Chiusura file, socket client e thread */
  close(fh);
  closesocket(sockC);
  printf("............Socket client %d: chiuso\n",sockC);
  ExitThread(5);
}

